IDENTIFICATION DIVISION.
*=======================
PROGRAM-ID. READFILE.
* Detta r ett enkelt program som lser en sekvensiell textfil
* med rader som avslutas med CR/LF och listar den 24 rader t gngen

ENVIRONMENT DIVISION.
*====================
INPUT-OUTPUT SECTION.
FILE-CONTROL.
    SELECT FILE1 ASSIGN TO FILENAME1
    FILE STATUS IS FILE1_FS.

DATA DIVISION.
*=============
FILE SECTION.
FD  FILE1
    VALUE OF FILE-ID IS FILENAME1
    DATA RECORD IS RECORD1.
01  RECORD1.
    05  TEXT1      PIC X(1).
WORKING-STORAGE SECTION.
01  FILENAME1      PIC X(12).
77  FILE1_FS       PIC 99.
77  IO_FLAG        PIC X.
    88 NEXT1       VALUE "N".
    88 EOF1        VALUE "E".
01  LINE_NO        PIC 99.
01  CR             PIC X.
77  PAGE_SIZE      PIC 99 COMP VALUE 25.

PROCEDURE DIVISION.
*==================
MAIN.
    DISPLAY "READFILE - Lser en sekvensiell fil och visar dess innehll."
    DISPLAY "Indata filnamn:" WITH NO ADVANCING
    ACCEPT FILENAME1
    MOVE 1 TO LINE_NO
    OPEN INPUT FILE1
    SET NEXT1 TO TRUE
    PERFORM WITH TEST AFTER UNTIL EOF1
        READ FILE1
        IF FILE1_FS NOT = 0
           SET EOF1 TO TRUE
        ELSE
           IF TEXT1 >= " "
               DISPLAY TEXT1 WITH NO ADVANCING
           ELSE
               DISPLAY ""
               READ FILE1
               IF FILE1_FS NOT = 0
                   SET EOF1 TO TRUE
               ELSE
                   ADD 1 TO LINE_NO
                   IF LINE_NO = PAGE_SIZE
                       PERFORM NEXT_PAGE
                   END-IF
               END-IF
           END-IF
        END-IF
    END-PERFORM
    CLOSE FILE1
    PERFORM NEXT_PAGE
    STOP RUN
    .
NEXT_PAGE.
    PERFORM UNTIL LINE_NO = PAGE_SIZE
        DISPLAY ""
        ADD 1 TO LINE_NO
    END-PERFORM
    DISPLAY "Tryck p 'Enter' fr fortsttning" WITH NO ADVANCING
    ACCEPT CR
    MOVE 1 TO LINE_NO
    .
